#include <stdlib.h>
#include <stdio.h>
#include <signal.h>
#include "err.h"

void catch_segv(int sig)
{
  sigset_t block_mask;
    
  printf("Cleaning up...");      /* here we do our cleanning up */
  while (getchar() != '\n');

  sigemptyset(&block_mask);	 /* unblock SIGSEGV signal */
  sigaddset(&block_mask, SIGSEGV);
  if (sigprocmask(SIG_UNBLOCK, &block_mask, 0) == -1)
    syserr("sigprocmask"); 
    
  if (raise(SIGSEGV) == -1)	 /* and raise it */
    syserr("raise");
}

int main ()
{
  char *text = "Dummy";
  struct sigaction setup_action;
  sigset_t block_mask;

  sigemptyset(&block_mask);	        /* add SIGINT & SIGQUIT to the set */ 
  sigaddset(&block_mask, SIGINT);
  sigaddset(&block_mask, SIGQUIT);
  setup_action.sa_handler = catch_segv; /* set the signal handler */
  setup_action.sa_mask = block_mask;    /* set block mask for the signal */
  setup_action.sa_flags = SA_ONESHOT;   /* set for only one signal occurence */
  if (sigaction (SIGSEGV, &setup_action, 0) == -1) /* set new hondler */
    syserr("sigaction2");

  *text = 'Y';     			/* 'calling' SIGSEGV :-) */
  return 0;
}
