#include <signal.h>
#include <stdio.h>
#include "err.h"

void a_handler (int signum)
{
  psignal (signum, "Caught signal"); /* print the signal info */
}


int main ()
{
  int i;
  struct sigaction old, new;
    
  new.sa_handler = a_handler; /* set own handler */
  sigemptyset(&new.sa_mask);  /* set empty mask signals set */
  new.sa_flags = 0;	      /* set flags */

  for (i = 1; i < NSIG; i++) { /* for all signals 'i' do: */
    if (sigaction(i, 0, &old) == -1) /* get the current signal action */
      syserr("sigaction");

				     /* print the signal action information */
    printf("Sig %d - handler: %s, flags: %x, text: %s\n", i, 
           old.sa_handler == SIG_DFL ? "SIG_DFL" : "SIG_IGN", 
           old.sa_flags, sys_siglist[i]);

    if (sigaction(i, &new, 0) == -1) /* set new signal action */
      printf( "You can\'t ovveride signal %d handler.\n", i);
  }
  
  while(getchar() != '\n');   /* wait for character written from keyboard */
  return 0;
}
